unit pph_viewer_control;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  pphtypes, pphbits, pph, pph_viewer_unit, StdCtrls, ComCtrls;

type
  TPPHControlForm = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    TrackBar2: TTrackBar;
    Button1: TButton;
    Button2: TButton;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    GroupBox4: TGroupBox;
    Label5: TLabel;
    GroupBox5: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button2Click(Sender: TObject);
  private
    Fpph: TPPH;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PPHControlForm: TPPHControlForm;

implementation

function IntToFloat (i, e: Integer): string;
begin
  Result := IntToStr(i div e) + ',';
  i := (i mod e)*100 div e;
  if i < 10 then
    Result := Result + '0';
  Result := Result + IntToStr(i);
end;

{$R *.DFM}

procedure TPPHControlForm.TrackBar1Change(Sender: TObject);
var
  n: Integer;
begin
  n := TrackBar1.Position;
  Label1.Caption := IntToStr(n div 10) + ',' + IntToStr(n mod 10) + '%';
end;

procedure TPPHControlForm.TrackBar2Change(Sender: TObject);
var
  n: Integer;
begin
  n := TrackBar2.Position;
  Label2.Caption := IntToStr(n div 10) + ',' + IntToStr(n mod 10) + '%';
end;

procedure TPPHControlForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  Form1.Image1.Visible := True;
  Form1.Image2.Visible := False;
end;

procedure TPPHControlForm.Button1Click(Sender: TObject);
var
  port: TPPHbits;
  dest: TPPH;
  bmp: TBitmap;
  size, numq: Integer;
begin
  Form1.Image1.Visible := False;
  Form1.Image2.Visible := True;
  //
  bmp := TBitmap.Create;
  dest := TPPH.Create;
  port := TPPHbits.Create;
  port.PutBitInit;
  Form1.Fpph.SaveCreamOfQPart (port, dest, TrackBar1.Position, TrackBar2.Position, TrackBar2.Position);
  port.ClearBits;
  dest.ToBitmap (bmp);
  Form1.Image2.Canvas.Draw (0,0, bmp);
  dest.Destroy;
  bmp.Destroy;
  // Y size
  size := Form1.Fpph.sizeY;
  numq := Form1.Fpph.numqY;
  Label3.Caption := IntToFloat ((size+7)div 8, 1024) + 'K';
  Label6.Caption := IntToFloat (size*100 div numq, 100);
  // Cb + Cr = colors_size
  size := Form1.Fpph.sizeCb + Form1.Fpph.sizeCr;
  numq := Form1.Fpph.numqCb + Form1.Fpph.numqCr;
  Label4.Caption := IntToFloat ((size+7)div 8, 1024) + 'K';
  Label7.Caption := IntToFloat (size*100 div numq, 100);
  // sum size
  Inc (size, Form1.Fpph.sizeY);
  Inc (numq, Form1.Fpph.numqY);
  Label5.Caption := IntToFloat ((size+7)div 8, 1024) + 'K';
  Label8.Caption := IntToFloat (size*100 div numq, 100);
  //
  port.Destroy;
end;

procedure TPPHControlForm.Button2Click(Sender: TObject);
var
  port: TPPHbits;
  dest: TPPH;
  bmp: TBitmap;
begin
  //
  dest := TPPH.Create;
  port := TPPHbits.Create;
  port.PutBitInit;
  Form1.Fpph.SaveCreamOfQPart (port, dest, TrackBar1.Position, TrackBar2.Position, TrackBar2.Position);
  port.SaveToFile (Form1.SaveDialog1.FileName);
  Form1.Title := Form1.SaveDialog1.FileName;
  port.ClearBits;
  port.Destroy;
  // make result image
  Form1.Fpph.Destroy;
  Form1.Fpph := dest;
  bmp := TBitmap.Create;
  dest.ToBitmap (bmp);
  Form1.Image1.Canvas.Draw (0,0, bmp);
  Form1.Fbmp.Assign (bmp);
  bmp.Destroy;
  // form close
  Close;
end;

end.
